#- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Uppsala University - 2017 spring, period 4
# Computer Architecture, 1DT093
# Lab 1: MIPS - Arrays, strings, loops and subroutines.
# Copyright 2017-04-06 Henrik D Schulze
# http://www.eit.lth.se/fileadmin/eit/courses/eit090/MIPS_IR.pdf from http://www.mrc.uidaho.edu/mrc/people/jff/digital/MIPSir.html (?)
#- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

	.data
ARRAY_SIZE:		.word	10	# Change here to try other values (less than 10)
FIBONACCI_ARRAY:	.word	1, 1, 2, 3, 5, 8, 13, 21, 34, 55
# STR_str:		.asciiz "Hunden, Katten, Glassen"
STR_str:		.asciiz "abc"


#- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
#- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
##	  You don't have to change anyghing below this line, except for
##	  task 5. Which part of the "main" section should you modify?
#- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
#- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Strings used by main:
#- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	.data
NLNL:	.asciiz "\n\n"
STRa_sum_of_fibonacci:	.asciiz "The sum of the "
STRb_sum_of_fibonacci:	.asciiz " first Fibonacci numbers is "
STR_string_length:	.asciiz	"\n\nstring_length(str) = "
STR_for_each_ascii:	.asciiz "\n\nstring_for_each(str, ascii)\n"
STR_for_each_to_upper:	.asciiz "\n\nstring_for_each(str, to_upper)\n\n"
STR_reverse:		.asciiz "\n\nreverse_string(str)\n\n"
	.text
	.globl main

#- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# MAIN: Main calls various subroutines and print out results.
#- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	.text
main:
	# addi $sp,$sp,-4	# main: invoked here. - PUSH the return address to the stack. (Overkill in main? No?)
	# sw	$ra, 0($sp)

	##
	### integer_array_sum
	##

	li	$v0, 4
	la	$a0, STRa_sum_of_fibonacci
	syscall

	lw	$a0, ARRAY_SIZE
	li	$v0, 1
	syscall

	li	$v0, 4
	la	$a0, STRb_sum_of_fibonacci
	syscall

	la	$a0, FIBONACCI_ARRAY
	lw	$a1, ARRAY_SIZE
	jal	integer_array_sum

	# Print sum
	add	$a0, $v0, $zero
	li	$v0, 1
	syscall

	li	$v0, 4
	la	$a0, NLNL
	syscall

	la	$a0, STR_str
	jal	print_test_string

	##
	### string_length
	##

	li	$v0, 4
	la	$a0, STR_string_length
	syscall

	la	$a0, STR_str
	jal	string_length

	add	$a0, $v0, $zero
	li	$v0, 1
	syscall

	##
	### string_for_each(string, ascii)
	##

	li	$v0, 4
	la	$a0, STR_for_each_ascii
	syscall

	la	$a0, STR_str
	la	$a1, ascii
	jal	string_for_each

	##
	### string_for_each(string, to_upper)
	##

	li	$v0, 4
	la	$a0, STR_for_each_to_upper
	syscall

	la	$a0, STR_str
	la	$a1, to_upper
	jal	string_for_each

	la	$a0, STR_str
	jal	print_test_string

	##
	### reverse(string, length)
	##

	li	$v0, 4
	la	$a0, STR_reverse
	syscall

	la	$a0, STR_str
	jal	string_length
	add	$a1, $zero, $v0

	la	$a0, STR_str
	jal	reverse

	la	$a0, STR_str
	jal	print_test_string

	# EXIT!
	li	$v0, 10
	syscall

	# lw	$ra, 0($sp)	# POP return address
	# addi	$sp, $sp, 4
	# jr	$ra

#- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# DESCRIPTION:  For an array of integers, returns the total sum of all
#		elements in the array.
#
# INPUT:	$a0 - address to first integer in array.
#		$a1 - size of array, i.e., numbers of integers in the array.
#
# OUTPUT:       $v0 - the total sum of all integers in the array.
#- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
integer_array_sum:# string_length: invoked.
DBG:	##### DEBUGG BREAKPOINT ######
	addi $v0,$zero,0	# integer_array_sum: invoked here. Initialize sum $v0 to zero.
	add $t0,$zero,$zero	# Initialize array index i to zero.

for_all_in_array:
	#### Append a MIPS-instruktion before each of these comments:
	beq $t0,$a1,end_for_all	# Done if i == N; for_all_in_array: beq $r,$s,L - Branch to L if $r EQuals $s
	sll $t1,$t0,2		# 4*i; sll $d,$t,h - Shift Left Logical, h=2 => 2^h = 4. (Zeroes shifted in.)
	add $t2,$a0,$t1		# address = ARRAY + 4*i; add $d,$s,$t - ADD $s and $t, store the sum in $d.
	lw $t3,0($t2)		# n = A[i]; lw $t,offset($s) - Load Word into $t that <offset($s)> POINTS to.
	add $v0,$v0,$t3		# Sum = Sum + n; add $v0,$v0,$t3 - ADD $v0 and $t3, store the sum in $v0.
	addi $t0,$t0,1		# i++
	j for_all_in_array	# next element; jump six lines up!

end_for_all:
	jr	$ra	# Return to caller; end_for_all:

#- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# DESCRIPTION: Gives the length of a string.
#
#       INPUT: $a0 - address to a NUL terminated string.
#
#      OUTPUT: $v0 - length of the string (NUL excluded).
#
#    EXAMPLE:  string_length("abcdef") == 6.
#- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
string_length:
	#### Write your solution here ####
	addi $v0,$zero,0# string_length: invoked. - ADD Immediate 0 to $zero & store to $v0; init strLength:=0.
	la $a0,STR_str	# la $t,L - Load Address of label L into $t; load address of STR_str into $a0.
	lb $t1,0($a0)	# lb $t,offs($s) - Load Byte from address that <offs($s)> POINTS to; 1st char in str.

loop0:
	beq $t1,$zero,done0	# beq $r,$s,L - Branch to L if $r EQuals $s. Exit loop0 when $t1 is NULL (0x00).
	addi $v0,$v0,1	# <strLength> ++
	addi $a0,$a0,1	# <string-element-address>++ (1-bit increment so that the next byte in Mem may be read.)
	lb $t1,0($a0)	# lb $t,offs($s) - Load Byte from address that <offs($s)> POINTS to; next char in str.
	j loop0		# j Target - Jump to the calculated address (indicated by Target); jump to <loop0>.

done0:
	jr $ra		# done0: jr $s - Jump to the address that Register $s POINTS to.

#- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
#
#  DESCRIPTION: For each of the characters in a string (from left to right),
#		call a callback subroutine.
#
#		The callback suboutine will be called with the _address_ of the character as the input parameter ($a0).
#
#	INPUT:	$a0 - address to a NUL terminated string.
#		$a1 - address to a callback subroutine.
#
#- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
string_for_each:
	addi $sp,$sp,-4	# string_for_each: invoked here. - PUSH return address of the caller to the stack.
	sw $ra, 0($sp)	# PUSH $ra to the stack because jal will be invoked which destroys the value.
	#### Write your solution here ####
	# By using $s-registers instead of $t-registers, we avoid pushing/poping to/from the stack inside the loop:
	addi $sp,$sp,-4	# Prepare $sp for a PUSH.
	sw $s0, 0($sp)	# Perform the PUSH.
	addi $sp,$sp,-4	# Prepare $sp for a PUSH.
	sw $s1, 0($sp)	# Perform the PUSH.

	add $s0,$a0,$zero	# Copy the address in $a0 to $s0.
	add $s1,$a1,$zero	# Copy the address in $a1 to $s1.

loop1:
	lb $t0,0($s0)		# - Load Byte into $t1 from what <offs($a0)> points to; first char in the string.
	beq $t0,$zero,done1	# - Branch to done1 if $t1 EQuals $zero [= NULL (0x00)].
	add $a0,$s0,$zero	# Pass the argument to the subroutine by copying it to $a0.
	jalr $s1		# jal L - Jump to L & Link = store ret-addr into $ra; invoke the callback subroutine.
	addi $s0,$s0,1		# <address-to-argument-used-by-the-callback-subroutine> ++
	j loop1			# 
done1:
	lw $s1, 0($sp)	# Perform the POP to restore the register.
	addi $sp,$sp,4	# Restore $sp after the POP.
	lw $s0, 0($sp)	# Perform the POP to restore the register.
	addi $sp,$sp,4	# Restore $sp after the POP.
	lw $ra, 0($sp)	# POP saved $ra from the stack - jal was invoked which destroyed the value.
	addi $sp,$sp,4	# POP return address to caller.
	jr $ra		# Leaving string_for_each: returning to main.

#- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
#  DESCRIPTION: Transforms a lower case character [a-z] to upper case [A-Z].
#
#	INPUT: $a0 - address of a character
#- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
to_upper:
	#### Write your solution here ####
	la $a0,STR_str	# to_upper: invoked - Load Address of label STR_str into a0. Points to start of string.
	li $t0,0	# Initialize address-index $t0 to 0.

loop2:
	add $t1,$t0,$a0			# Offset the character's address with index $t0.
	lb $t2,0($t1)			# Load Byte into $t2 from the address that 0($t1) points to.
	beq $t2,$zero,end_to_upper	# NULL encountered. The string ends here.
	blt $t2,97,next_char		# Ascii too small: this is not a lowercase letter. Next char.
	bgt $t2,122,next_char		# Ascii too large: this is neither a lowercase letter. Next char.
	add $t2,$t2,-32			# Ascii corresponds to a lowercase letter. Convert to uppercase!
	sb $t2,0($t1)			# Store the Byte in $t2 back to the same memory address it came from.

next_char:
	addi $t0,$t0,1	# Increment the index.
	j loop2		# jump back to the label loop2; continue looping.
end_to_upper:
	jr	$ra

#- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
#  DESCRIPTION: Reverses a string.
#
#	INPUT:	$a0 - address to a NUL terminated string.
#		$a1 - length of the string.
#- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
reverse:
	#### Write your solution here ####
	srl $t0,$a1,1

	add $t1,$a0,$zero	# $t1 is the iterator starting from the beginning of the string.
	add $t2,$a0,$a1		# Wait for it!
	addi $t2,$t2,-1		# $t2 is the iterator starting from the end of the string.

loop3:
	ble $t2,$t1,done3	# ble $t2,$t1,done3 - Branch to done3 if $t2 is Less or Equal to $t1.

	lb $t3,0($t1)		# - Load Byte into $t1 from what <offs($a0)> points to; first char in the string.
	lb $t4,0($t2)		# - Load Byte into $t1 from what <offs($a0)> points to; first char in the string.
	sb $t3,0($t2)		# Store the Byte in $t2 back to the same memory address it came from.
	sb $t4,0($t1)		# Store the Byte in $t2 back to the same memory address it came from.
	addi $t1,$t1,1		# $t2 is the iterator starting from the end of the string.
	addi $t2,$t2,-1		# $t2 is the iterator starting from the end of the string.

	# sb $t2,0($t1)			# Store the Byte in $t2 back to the same memory address it came from.

	# add $s1,$a1,$zero	# Copy the address in $a1 to $s1.
	j loop3			# 
done3:
	jr $ra

#- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
#  DESCRIPTION : Prints to console 'str = ' followed by the input string surronded by double quotes.
#
#	INPUT: $a0 - address to a NUL terminated string.
#- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
print_test_string:
	.data
STR_str_is:	.asciiz "str = \""
STR_quote:	.asciiz "\""

	.text
	add $t0, $a0, $zero	# print_test_string: invoked here, save the contents of $a0 into $t0 for backup.

	la $a0, STR_str_is
	li $v0, 4
	syscall			# Print "str = \""

	add	$a0, $t0, $zero	# Restore the saved contents in $t0 back to $a0.
	syscall			# Print the original contents of $a0.

	la $a0, STR_quote
	syscall			# Print the final double quote.

	jr	$ra

#- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
#  DESCRIPTION: Prints out the Ascii value of a character.
#
#	INPUT: $a0 - address of a character
#- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
ascii:
	.data
STR_the_ascii_value_is:	.asciiz "\nAscii('X') = "

	.text
	la $t0, STR_the_ascii_value_is	# ascii: invoked here.

	# Replace X with the input character:
	add $t1, $t0, 8	# Position of X
	lb $t2, 0($a0)	# Get the Ascii value
	sb $t2, 0($t1)

	# Print "The Ascii value of...":
	add	$a0, $t0, $zero
	li	$v0, 4
	syscall

	# Append the Ascii value:
	add	$a0, $t2, $zero
	li	$v0, 1
	syscall

	jr	$ra
	# addi $s2,$s2,1	# <address-to-argument-used-by-the-callback-subroutine> ++
	# jalr $s1	# jal L - Jump to L & Link = store ret-addr into $ra; invoke the callback subroutine.
	# lb $t1,0($s2)	# - Load Byte into $t1 from what 0($a1) points to; read the next char in the string.
	# add $a0,$s1,$zero	# Copy the address in $a1 to $a0.
	# j loop1		# jump back to the label loop1; continue looping.
	# # la $a0,STR_str	# - Load Address of label STR_str into a0, to be used by string_for_each.
	# # la $a1,STR_str	# - Load Address of label STR_str into a1, to be used by the callback subroutine.
	# lb $t1,0($s2)	# - Load Byte into $t1 from what <offs($a0)> points to; first char in the string.
# loop1:
	# beq $t1,$zero,done1	# - Branch to done1 if $t1 EQuals $zero [= NULL (0x00)].
	# addi $s2,$s2,1	# <address-to-argument-used-by-the-callback-subroutine> ++
	# jalr $s1	# jal L - Jump to L & Link = store ret-addr into $ra; invoke the callback subroutine.
	# lb $t1,0($s2)	# - Load Byte into $t1 from what 0($a1) points to; read the next char in the string.
	# add $a0,$s1,$zero	# Copy the address in $a1 to $a0.
	# j loop1		# jump back to the label loop1; continue looping.
